import {ApiCall} from "tsrpc";
import {GHManage} from '../../public/gonghui/manage';
import {ReqGetList, ResGetList} from "../../shared/protocols/gonghui/PtlGetList";

export default async function (call: ApiCall<ReqGetList, ResGetList>) {

    let arr: ResGetList['list'] = [];
    let GHData = await GHManage.getGHList();
    let ghs = Object.values(GHData).map(item => item.data).filter(i => !!i.players);

    let fuids = R.flatten(ghs.map(i => i.players.map(j => j.uid)))

    let allRoles = await G.mongodb.find('user',{uid: {$in: fuids}},['uid','power'])
    let zhanlis = Object.fromEntries(allRoles.map(r => [r.uid, r.power]));

    for (let gh of ghs) {
        let uids = gh.players.map(p => p.uid);
        let zhanli = uids.map(u => (zhanlis[u] || 0)).reduce((a, b) => a + b);
        arr.push({
            gh: gh,
            zhanli: zhanli
        });
    }

    call.succ({
        list: arr
    });
}